/*****************************************************************************
 *
 * utouch-frame - Touch Frame Library
 *
 * Copyright (C) 2011 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ****************************************************************************/

#include "v2/axis.h"

#include "v2/value.h"

namespace utouch {
namespace frame {

UFAxis::UFAxis(UFAxisType type, float min, float max, float resolution)
    : type_(type), min_(min), max_(max), resolution_(resolution) {
}

} // namespace frame
} // namespace utouch

extern "C" {

UFAxisType frame_axis_get_type(UFAxis axis) {
  return static_cast<const utouch::frame::UFAxis*>(axis)->type();
}

float frame_axis_get_minimum(UFAxis axis) {
  return static_cast<const utouch::frame::UFAxis*>(axis)->min();
}

float frame_axis_get_maximum(UFAxis axis) {
  return static_cast<const utouch::frame::UFAxis*>(axis)->max();
}

float frame_axis_get_resolution(UFAxis axis) {
  return static_cast<const utouch::frame::UFAxis*>(axis)->resolution();
}

} // extern "C"
