/*****************************************************************************
 *
 * utouch-frame - Touch Frame Library
 *
 * Copyright (C) 2011 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ****************************************************************************/

#ifndef UTOUCH_FRAME_DEVICE_H_
#define UTOUCH_FRAME_DEVICE_H_

#include <map>
#include <memory>

#include "utouch/frame.h"
#include "v2/axis.h"
#include "v2/typedefs.h"

struct UFDevice_ {};

namespace utouch {
namespace frame {

class UFDevice : public UFDevice_, public Property<UFDeviceProperty> {
 public:
  UFDevice() {}

  UFStatus GetAxisByIndex(unsigned int index, ::UFAxis* axis) const;
  UFStatus GetAxisByType(UFAxisType type, ::UFAxis* axis) const;

  UFDevice(const UFDevice&) = delete;
  UFDevice& operator=(const UFDevice&) = delete;

 protected:
  typedef std::unique_ptr<UFAxis> UniqueUFAxis;

  std::map<UFAxisType, UniqueUFAxis> axes_;
};

} // namespace frame
} // namespace utouch

#endif // UTOUCH_FRAME_DEVICE_H_
