/*****************************************************************************
 *
 * utouch-frame - Touch Frame Library
 *
 * Copyright (C) 2011 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ****************************************************************************/

#ifndef UTOUCH_FRAME_HANDLE_H_
#define UTOUCH_FRAME_HANDLE_H_

#include <queue>

#include "utouch/frame.h"

struct UFHandle_ {};

namespace utouch {
namespace frame {

class UFEvent;

class UFHandle : public UFHandle_ {
 public:
  UFHandle();
  ~UFHandle();

  int event_fd() const { return event_fd_; }
  UFStatus GetEvent(::UFEvent* event);
  void ReleaseEvent(UFEvent event);

 protected:
  void EnqueueEvent(UFEvent*);

  UFHandle(const UFHandle&) = delete;
  UFHandle& operator=(const UFHandle&) = delete;

 private:
  int event_fd_;
  std::queue<UFEvent*> event_queue_;
};

} // namespace frame
} // namespace utouch

#endif // UTOUCH_FRAME_HANDLE_H_
