/*****************************************************************************
 *
 * utouch-frame - Touch Frame Library
 *
 * Copyright (C) 2011 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ****************************************************************************/

#include "v2/window.h"

#include <assert.h>

#include "v2/frame.h"

namespace utouch {
namespace frame {

Window::Window() : current_frame_(new UFFrame) {
}

bool Window::IsTouchOwned(UFTouchId touchid) const {
  return current_frame_->IsTouchOwned(touchid);
}

void Window::ReleaseFrames() {
  current_frame_ = SharedUFFrame(new UFFrame);
}

bool Window::IsContextEnded() const {
  return current_frame_->IsEnded();
}

} // namespace frame
} // namespace utouch
